// Copyright:	(C) Alexander S. Naumov aka GooRoo, 2004.
// E-mail:		gooroo@bk.ru
// Last update:	23/05/2004

using System;
using System.Runtime.Serialization;

using LoCoL.Collections;

namespace LoCoL
{
	/// <summary>
	///   .
	/// </summary>
	[Serializable]
	public class StateGroup : NamedObject, IChangeable, ISerializable
	{

		#region Public Constructors

		/// <summary>
		/// .
		/// </summary>
		public StateGroup( int id, string name )
			: this( id, name, null )
		{
		}

		/// <summary>
		/// .
		/// </summary>
		public StateGroup( int id, string name, StateSet states )
			: base( id, name )
		{
			m_States =
				( states == null ) ? ( new StateSet() ) : ( states.Clone() );
			m_States.Changed += new ChangedEventHandler( RaiseChangedEvent );
		}

		#endregion

		#region ISerializable Implementation

		/// <summary>
		///  .
		/// </summary>
		protected StateGroup(
			SerializationInfo info,
			StreamingContext context )
			: base( info, context )
		{
			m_States = (StateSet)info.GetValue( "States", typeof(StateSet) );
			m_States.Changed += new ChangedEventHandler( RaiseChangedEvent );
		}

		/// <summary>
		///    .
		/// </summary>
		public override void GetObjectData(
			SerializationInfo info,
			StreamingContext context )
		{
			base.GetObjectData( info, context );
			info.AddValue( "States", m_States );
		}

		#endregion

		#region Private Members

		/// <summary>
		/// ,    .
		/// </summary>
		private StateSet m_States;

		#endregion

		#region Public Properties

		/// <summary>
		/// ,    .
		/// </summary>
		public StateSet States
		{
			get
			{
				return m_States;
			}
		}

		#endregion

		#region IChangeable Implementation

		/// <summary>
		/// , ,     .
		/// </summary>
		public event ChangedEventHandler Changed;

		private void RaiseChangedEvent( object sender, ChangedEventArgs e )
		{
			if ( Changed != null )
			{
				Changed( this, e );
			}
		}

		#endregion
	}
}
